`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date: 2019/04/22 19:35:26
// Design Name: 
// Module Name: topmodule
// Project Name: 
// Target Devices: 
// Tool Versions: 
// Description: 
// 
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////

module topmodule(
    clk, // clock from crystal
    rst_n, // active low reset
    audio_mclk, // master clock
    audio_lrck, // left-right clock
    audio_sck, // serial clock
    audio_sdin // serial audio data input
);

    input clk; // clock from the crystal
    input rst_n; // active low reset
    output audio_mclk; // master clock
    output audio_lrck; // left-right clock
    output audio_sck; // serial clock
    output audio_sdin; // serial audio data input

    wire clk_1Hz;
    wire clk_100Hz;
    wire [1:0] clk_ssd_ctl;
    
    wire [15:0] audio_in_left, audio_in_right;
    wire [21:0] note_gen_data;

    clock_generator U0(
    .clk_1Hz(clk_1Hz), //divided clock output
    .clk_100Hz(clk_100Hz),
    .clk_ctl(clk_ssd_ctl), //clock for 7-segment
    .clk(clk),    //clock input
    .rst_n(rst_n)   //low-active reset
);

    voice_setting U1(
    .clk_1Hz(clk_1Hz), //divided clock output
    .rst_n(rst_n),   //low-active reset
    .note_gen_data(note_gen_data)
);

    note_gen Ung(
    .clk(clk), // clock from crystal
    .rst_n(rst_n), // active low reset
    .note_div(note_gen_data), // div for note generation
    .audio_left(audio_in_left), // left sound audio
    .audio_right(audio_in_right) // right sound audio
    );

// Speaker controllor
    speaker_control Usc(
    .clk(clk), // clock from the crystal
    .rst_n(rst_n), // active low reset
    .audio_in_left(audio_in_left), // left channel audio data input
    .audio_in_right(audio_in_right), // right channel audio data input
    .audio_mclk(audio_mclk), // master clock
    .audio_lrck(audio_lrck), // left-right clock
    .audio_sck(audio_sck), // serial clock
    .audio_sdin(audio_sdin) // serial audio data input
    );
endmodule



